// contain  some graphic, save, print, .. functions

#include "random.h"






///// SPECIFIC algebra fx2 functions
#define TXTCURSOR_X (peekb(0x45,0x0))
#define TXTCURSOR_Y (peekb(0x45,0x1))

void __cdecl gotoxy(int x,int y);

#define FONT_1  0xCE50
#define FONT_2  0xCED0
#define FONT_3  0xCF50



#define NORMAL  0
#define TEXT    1
#define MASK    2
#define INVERS  4

void text(int x,int y,unsigned char far* text,unsigned char mode,unsigned int segm)         // this function isn't very useful. You can forget it.
{
  int max=segm-0x38;
  asm{
       push ds
       mov al,0x1
       and al,mode          // Si le mode graphique est active
       je graph_mode        // on passe directement a la suite.
       //dec x                // Sinon on convertit les coordonnees
       mov ax,x             // du mode texte en coordonnees pour
       shl ax,0x2           // le mode graphique.
       shl x,0x1
       add x,ax
       //dec y
       shl y,0x3
     }
  graph_mode :
  asm{
       mov ax,segm
       mov dx,y
       sub ax,dx
       mov es,ax
       lds si,text         // On sauve l'adresse du texte
       push si             // a afficher.
       push ds


     }

  char_loop :              // Le changement de caractere.
  asm{
       pop ds
       pop si
       mov al,ds:[si]      // On charge le caractere a afficher.
       cmp al,0x0          // On teste si c'est le dernier caractere
       je end              // a afficher. Si non, on fait
       inc si              // pointer SI sur le caractere suivant et on
       push si             // sauvegarde l'adresse du prochain caractere.
       push ds
       mov dx,FONT_1       // On charge la police normale.
       mov ds,dx
       xor ah,ah           // on recherche l'adresse du sprite a afficher.
       shl ax,0x3          // adresse -> FONT_1:(caractere * 8)
       mov si,ax

       mov di,0x3FE        // Pour chaque caractere, on recalcule
       mov cx,x            // l'octet sur lequel on doit commencer
       mov ax,cx           // a afficher.
       shr ax,0x3
       sub di,ax
       and cl,0x7
       mov ch,0x8
       mov bx,0x01FF       // On cree le masque correct.
       ror bx,cl
     }
     nrm_test:                // Si aucun clipping, on execute
  asm{                     // les fonctionalites de chaque mode.
       mov al,0x2
       and al,mode
       jne nrm_mask_loop
	   mov al,0x4
	   and al,mode
	   jne nrm_inv_loop
     }

  nrm_loop:
  asm{
       xor ah,ah
       lodsb
       xchg ah,al
       shr ax,cl
       or es:[di],ax
       or es:[di+0x800],ax
       or es:[di+0x1000],ax
       sub di,0x10
       dec ch
       jne nrm_loop
       jmp suite
     }

  nrm_mask_loop:
  asm{
       and es:[di],bx         // On pose le masque sur chaque caractere.
       and es:[di+0x800],bx
       and es:[di+0x1000],bx
       xor ah,ah
       lodsb
       xchg ah,al
       shr ax,cl
       or es:[di],ax
       or es:[di+0x800],ax
       or es:[di+0x1000],ax         // Puis le sprite.
       sub di,0x10
       dec ch
       jne nrm_mask_loop
       jmp suite
     }

  nrm_inv_loop:
  asm{
       xor ah,ah
       lodsb
       xchg ah,al
       shr ax,cl
       xor es:[di],ax
       xor es:[di+0x800],ax
       xor es:[di+0x1000],ax          // Puis le sprite.
       sub di,0x10
       dec ch
       jne nrm_inv_loop
     }


  suite:
     asm {
       


       add x,0x6              // On gere les consequences du changement
       cmp x,0x78
       jle char_loop          // Si le caractere sort de
       mov x,0x0              // l'ecran, x=0
       mov ax,es              // et on change de ligne.
       sub ax,0x8
       cmp max, ax
       jg end
       mov es,ax
       jmp char_loop
     }
  end : asm pop ds
}

//


void setPix(short X,short Y,short page,unsigned char couleur){
asm {
	mov cx,page  //numero de page   //4
	shl cx,6     //multiplication par 64 //2
	add cx,0x1a20  //ajout de la page 0  //2
	mov es,cx  //on le met dans es    //2
	mov si,63
	mov cx,127
	sub si,Y //On copie y   //4
	sub cx,X //On copie x   //4
	mov bx,cx //On en fait une copie  //2
	and cx,7 //Reste de division par 8 dans cl //2
	shr bx,3 //on divise par 8 //3
	shl bx,6 //On multiplie par 64  //2
	add si,bx //On ajoute le tout a si //1
	mov al,couleur
	mov bl,es:[si] // Recupere le byte a changer
	db 0x0F,0x12,0x0C3      // clr1 bl,cl (specifique au nec v20/30)
	rol al,cl		// met le 1 (si 1) a la place voulue
	or bl,al		// Ecris le 1 (si 1)
	mov es:[si],bl };}	// Remet le byte
	
	
	
char tstpixel(int X, int Y,int page) {

asm {	mov cx,page  //numero de page   //4
	shl cx,6     //multiplication par 64 //2
	add cx,0x1a20  //ajout de la page 0  //2
	mov es,cx  //on le met dans es    //2
	mov si,63 //on met 64
	mov cx,127 //on met 128
	sub si,Y //On enleve y   //4
	sub cx,X //On enleve x   //4
	mov bx,cx //On en fait une copie  //2
	and cx,7 //Reste de division par 8 dans cl //2
	shr bx,3 //on divise par 8 //3
	shl bx,6 //On multiplie par 64  //2
	add si,bx //On ajoute le tout a si //1
	mov al,es:[si];
	ror al,cl;
	and al,1; }
return _AL; }


void contplus(){   // change contrast
asm{mov bl,0
mov ah,0x22
int 0x7C};};


void contless(){    
asm{mov bl,1
mov ah,0x22
int 0x7C};};

/* ---------------------------------------
           Fonctions de scrolling
   --------------------------------------- */

// scrollings functions on Algebra fx2.
// Ces fonctions ont t crites par swifter, et je les aient amliores. elles sont plus rapide

void rightscroll( char x)  // x est le dcalage souhait.
{
  asm{
    push ds
    cld
    mov ax,0x1A60      // met le buffer 1
  mov es,ax
  mov ds,ax
  mov ch, 3 // 3 buffer
  mov cl,x       // calcul du decalage en fonction de x
       and cl, 0x7
       mov bh, 0x1
       shl bh, cl
       dec bh
  }
  unbuffer:
  asm{
       xor di,di       // met 15 dans si (bloc de donnee en bas a gauche du buffer)
       xor si,si        // efface di, di=0 (bloc de donnee en bas a droite)

       xor ax, ax//ax = 0
       mov dh,0x40      // dh=64; nombre de fois a repeter la boucle(nombre de lignes d'un buffer)

     }   
     //1 loop enlev et le chargement de la data optimis
     loopline:             // debut de la double boucle
  asm{
       mov bl,es:[di+0xF]   // bl = bloc de donnee source
       rol bl,cl        // decalage de bl pour faire correspondre le bit voulu au niveau du bit 0
       and bl,bh       // efface les bits inutiles (de 1 a 7) et garde le bit 0

     }
  asm{
       //1er
       lodsw//mov ax,ds:[si]   // ax = bloc de destination
       mov dl,ah        // la partie haute de ax dans dl
       rol dl,cl       // passe le 7eme bit au bit 0 par un decalage
       and dl,bh       // on garde le bit 0 de dl   ---
       shl ax,cl       // ax decale de 1
       or al,bl         // on met le contenu de dl dans al
       stosw//mov es:[di],ax   // on reaffiche le tout sur le buffer choisi (segm)
       mov bl,dl        // on met le contenu de dl dans bl
       //add si,0x2       // passe au bloc de destination suivant
       //2
       lodsw
       mov dl,ah        // la partie haute de ax dans dl
       rol dl,cl       // passe le 7eme bit au bit 0 par un decalage
       and dl,bh       // on garde le bit 0 de dl   ---
       shl ax,cl       // ax decale de 1
       or al,bl         // on met le contenu de dl dans al
       stosw
       mov bl,dl        // on met le contenu de dl dans bl

       //3e
       lodsw
       mov dl,ah        // la partie haute de ax dans dl
       rol dl,cl       // passe le 7eme bit au bit 0 par un decalage
       and dl,bh       // on garde le bit 0 de dl   ---
       shl ax,cl       // ax decale de 1
       or al,bl         // on met le contenu de dl dans al
       stosw
       mov bl,dl        // on met le contenu de dl dans bl
       //4e
       lodsw
       mov dl,ah        // la partie haute de ax dans dl
       rol dl,cl       // passe le 7eme bit au bit 0 par un decalage
       and dl,bh       // on garde le bit 0 de dl   ---
       shl ax,cl       // ax decale de 1
       or al,bl         // on met le contenu de dl dans al
       stosw
       mov bl,dl        // on met le contenu de dl dans bl
       //5e
      lodsw
       mov dl,ah        // la partie haute de ax dans dl
       rol dl,cl       // passe le 7eme bit au bit 0 par un decalage
       and dl,bh       // on garde le bit 0 de dl   ---
       shl ax,cl       // ax decale de 1
       or al,bl         // on met le contenu de dl dans al
       stosw
       mov bl,dl        // on met le contenu de dl dans bl
       //6e
       lodsw
       mov dl,ah        // la partie haute de ax dans dl
       rol dl,cl       // passe le 7eme bit au bit 0 par un decalage
       and dl,bh       // on garde le bit 0 de dl   ---
       shl ax,cl       // ax decale de 1
       or al,bl         // on met le contenu de dl dans al
       stosw
       mov bl,dl        // on met le contenu de dl dans bl
       //7e
       lodsw
       mov dl,ah        // la partie haute de ax dans dl
       rol dl,cl       // passe le 7eme bit au bit 0 par un decalage
       and dl,bh       // on garde le bit 0 de dl   ---
       shl ax,cl       // ax decale de 1
       or al,bl         // on met le contenu de dl dans al
       stosw
       mov bl,dl        // on met le contenu de dl dans bl
       //8e
       lodsw
       mov dl,ah        // la partie haute de ax dans dl
       rol dl,cl       // passe le 7eme bit au bit 0 par un decalage
       and dl,bh       // on garde le bit 0 de dl   ---
       shl ax,cl       // ax decale de 1
       or al,bl         // on met le contenu de dl dans al
       stosw

       dec dh           // decremente dh (dh correspond au nombre de ligne dans un buffer)
       jne loopline

       mov ax, es
       add ax, 0x80
       mov es, ax
       mov ds, ax
       dec ch
       jne unbuffer
       pop ds
     }
}







void leftscroll(char x)
{
  asm{
    push ds
    mov ax,0x1A60      // met le buffer 1
    std
  mov es,ax
  mov ds, ax
  mov ch, 3 // 3 buffer
 mov cl, x
       and cl,0x7       // calcul du decalage en fonction de x
       mov bh, 0x1
       shl bh, cl
       dec bh
  }
  unbuffer:
  asm{
       mov si,0x3FE     // (bloc de donnee en haut a gauche du buffer)
       mov di,0x3FE

       xor ax, ax
       mov dh,0x40

     }
      loopline:             // debut de la double boucle
  asm{
       mov bl,es:[si-0xE]   // bl = bloc de donnee source
       and bl,bh
       ror bl,cl   //shl bl,cl        // decalage de bl pour faire correspondre le bit voulu au niveau du bit 7

     }
  loop:                 // la deuxieme boucle
  asm{
    //1
      lodsw   // ax = bloc de destination
       mov dl,al        // la partie basse de ax dans dl
       and dl,bh       // on garde le bit 0 de dl
       ror dl,cl       // et on le passe au 7eme bit de dl
       shr ax,cl       // on decale ax de 1
       or ah,bl         // on met le contenu de dl dans ah
       stosw   // on reaffiche le tout sur le buffer choisi (segm)
       mov bl,dl        // on met le contenu de dl dans bl

       //2
       lodsw   // ax = bloc de destination
       mov dl,al        // la partie basse de ax dans dl
       and dl,bh       // on garde le bit 0 de dl
       ror dl,cl       // et on le passe au 7eme bit de dl
       shr ax,cl       // on decale ax de 1
       or ah,bl         // on met le contenu de dl dans ah
       stosw   // on reaffiche le tout sur le buffer choisi (segm)
       mov bl,dl        // on met le contenu de dl dans bl

       //3
       lodsw   // ax = bloc de destination
       mov dl,al        // la partie basse de ax dans dl
       and dl,bh       // on garde le bit 0 de dl
       ror dl,cl       // et on le passe au 7eme bit de dl
       shr ax,cl       // on decale ax de 1
       or ah,bl         // on met le contenu de dl dans ah
       stosw   // on reaffiche le tout sur le buffer choisi (segm)
       mov bl,dl        // on met le contenu de dl dans bl

       //4
       lodsw   // ax = bloc de destination
       mov dl,al        // la partie basse de ax dans dl
       and dl,bh       // on garde le bit 0 de dl
       ror dl,cl       // et on le passe au 7eme bit de dl
       shr ax,cl       // on decale ax de 1
       or ah,bl         // on met le contenu de dl dans ah
       stosw   // on reaffiche le tout sur le buffer choisi (segm)
       mov bl,dl        // on met le contenu de dl dans bl

       //5
       lodsw   // ax = bloc de destination
       mov dl,al        // la partie basse de ax dans dl
       and dl,bh       // on garde le bit 0 de dl
       ror dl,cl       // et on le passe au 7eme bit de dl
       shr ax,cl       // on decale ax de 1
       or ah,bl         // on met le contenu de dl dans ah
       stosw   // on reaffiche le tout sur le buffer choisi (segm)
       mov bl,dl        // on met le contenu de dl dans bl

       //6
       lodsw   // ax = bloc de destination
       mov dl,al        // la partie basse de ax dans dl
       and dl,bh       // on garde le bit 0 de dl
       ror dl,cl       // et on le passe au 7eme bit de dl
       shr ax,cl       // on decale ax de 1
       or ah,bl         // on met le contenu de dl dans ah
       stosw   // on reaffiche le tout sur le buffer choisi (segm)
       mov bl,dl        // on met le contenu de dl dans bl

       //7
       lodsw   // ax = bloc de destination
       mov dl,al        // la partie basse de ax dans dl
       and dl,bh       // on garde le bit 0 de dl
       ror dl,cl       // et on le passe au 7eme bit de dl
       shr ax,cl       // on decale ax de 1
       or ah,bl         // on met le contenu de dl dans ah
       stosw   // on reaffiche le tout sur le buffer choisi (segm)
       mov bl,dl        // on met le contenu de dl dans bl

       //8
       lodsw   // ax = bloc de destination
       mov dl,al        // la partie basse de ax dans dl
       and dl,bh       // on garde le bit 0 de dl
       ror dl,cl       // et on le passe au 7eme bit de dl
       shr ax,cl       // on decale ax de 1
       or ah,bl         // on met le contenu de dl dans ah
       stosw   // on reaffiche le tout sur le buffer choisi (segm)


       dec dh           // decremente dh (dh correspond au nombre de ligne dans un buffer)
       jne loopline
     mov ax, es
       add ax, 0x80
       mov es, ax
       mov ds, ax
       dec ch
       jne unbuffer
       cld
       pop ds
     }

}



void upscroll(char x)
{
  asm{
     push ds
      mov ax,0x1A60      // met le buffer 1
  mov es,ax
  mov ds,ax
  mov dh, 3 // 3 buffer
  cld
   }
   unbuffer:
   asm {
   mov al,x
   mov dl, al
  }


  retu:
  asm{


       mov di,0x0      // di=16; (bloc de donnee en bas a droite au dessus de l'octet 0)
       mov si,0x10


       mov cx,0x1F8     // nombre de fois a repeter la boucle (8*63=504)
       rep movsw     // on fait la mme chose que dans la vielle version, mais dans une seule ligne



       mov cx,0x8
       mov si,0
       sub si,0x3F         // si=(-y)
       shl si,0x4       // si=(-y)*16
       add si,0x3F0
      rep movsw      // de mme ici
      dec dl
       jne retu
       mov ax, es
       add ax, 0x80
       mov es, ax
       mov ds, ax
       dec dh
       jne unbuffer
       pop ds       //important car vieille version n'utilise pas ds, mais ici si.
     }


}




// Decale tout le buffer choisi(segm) vers le haut et
// rajoute la ligne designee par y

void downscroll( char x)
{
  
   asm{
     push ds
      mov ax,0x1A60      // met le buffer 1
  mov es,ax
  mov ds,ax
  mov dh, 3 // 3 buffer
  std
   }
   unbuffer:
   asm {
   mov al,x
   mov dl, al
  }
  retu:
  asm{


       mov di,0x3FE      // di=16; (bloc de donnee en bas a droite au dessus de l'octet 0)
       mov si,0x3EE

       mov cx,0x1F8     // nombre de fois a repeter la boucle (8*63=504)
       rep movsw

       // (la ligne disparue rpparait de l'autre cot
       mov cx,0x8
       mov si,0x3FE
      rep movsw

      dec dl
       jne retu
       mov ax, es
       add ax, 0x80
       mov es, ax
       mov ds, ax
       dec dh
       jne unbuffer
       cld
       pop ds
     }

}
void copypage(int source ,int target){asm{              // for White and black mode. copy a buffer to on other (screen = buffer 0)
	push ds
	mov ax,target
	shl ax,6
	add ax,0x1A20
	mov es,ax
	mov di,0
	mov ax,source
	shl ax,6
	add ax,0x1A20
	mov ds,ax
	mov si,0
	cld
	mov cx,512
	rep movsw
	pop ds};
}

////////

//////// Useful functions


// open watcom

double frexpff( double value, int *exp )
/**********************************************/
{
    int     n;
    union {
        double          x;
        unsigned short  a[4];
    } u;

    n = 0;
    u.x = value;
    if( value != 0.0 ) {
        n = (u.a[3] & 0x7ff0) >> 4;
        n -= 0x03fe;
        u.a[3] &= 0x800f;
        u.a[3] |= 0x3fe0;
    }
    *exp = n;
    return( u.x );
}

double ldexp( double value, int n )
{
    int     exp;
    union {
        double      x;
        short int   a[4];
    } u;

    u.x = value;
    if( value != 0.0 ) {
        exp = (u.a[3] & 0x7ff0) >> 4;
        if( n > 16000 ) n = 16000;
        if( n < -16000 ) n = -16000;
        exp += n;
        if( exp <= 0 ) {
            return( 0.0 );
        }

        exp = exp << 4;
        u.a[3] &= 0x800f;
        u.a[3] |= exp;
    }
    return( u.x );
    }
    
// inspired by a GNU modf function (super fast)


 #define isnan __IsNan

struct f64
 {
         unsigned long low_word;
         unsigned long high_word;
 };

 #define F64_SIGN_SHIFT  31
 #define F64_SIGN_MASK   1

 #define F64_EXP_SHIFT   20
 #define F64_EXP_MASK    0x7ff
 #define F64_EXP_BIAS    1023
 #define F64_EXP_MAX     2047

 #define F64_MANT_SHIFT  0
 #define F64_MANT_MASK   0xfffff

 #define F64_GET_SIGN(fp)        (((fp)->high_word >> F64_SIGN_SHIFT) & \
                                         F64_SIGN_MASK)
 #define F64_GET_EXP(fp)         (((fp)->high_word >> F64_EXP_SHIFT) & \
                                         F64_EXP_MASK)
 #define F64_SET_EXP(fp, val)    ((fp)->high_word= ((fp)->high_word &    \
                                 ~(F64_EXP_MASK << F64_EXP_SHIFT)) |     \
                                 (((val) & F64_EXP_MASK) << F64_EXP_SHIFT))

#define F64_GET_MANT_LOW(fp)            ((fp)->low_word)
#define F64_SET_MANT_LOW(fp, val)       ((fp)->low_word= (val))
#define F64_GET_MANT_HIGH(fp)   (((fp)->high_word >> F64_MANT_SHIFT) & \
                                         F64_MANT_MASK)
#define F64_SET_MANT_HIGH(fp, val)      ((fp)->high_word= ((fp)->high_word & \
                                 ~(F64_MANT_MASK << F64_MANT_SHIFT)) |   \
                                (((val) & F64_MANT_MASK) << F64_MANT_SHIFT))


#define F32_EXP_SHIFT  23
#define F32_EXP_MASK    0xFF
#define F32_EXP_BIAS    127
#define MASKmantisse 0x007FFFFF


#define F32_GET_EXP(fp)         (((fp)->word >> F32_EXP_SHIFT) & \
                                         F32_EXP_MASK)
#define F32_GET_MANT(fp)            ((fp)->word & MASKmantisse)
#define F32_SET_MANT(fp, val)       ((fp)->word= (((fp)->word & 0xFF800000)|(val & MASKmantisse)))

struct f32
 {
         unsigned long word;
 };


float floorff( float value )
{

         struct f32 *f32p;
         int exp;
         int mask_bits;
         unsigned long mant;
         char sgn = (value < 0);

         f32p= (struct f32 *)&value;

         exp= F32_GET_EXP(f32p);
         exp -= F32_EXP_BIAS;
         if (exp < 0)
         {
                 return 0;
         }
         mask_bits= 23-exp;
         if (mask_bits <= 0)
         {
                 return value;
         }

                 mant= F32_GET_MANT(f32p);
                if(mask_bits>=16) {
                 struct f16 *fpp=(struct f16 *)&mant;
                 fpp->word1=0;
                 if(mask_bits!=16)fpp->word2 &= ~((1 << (mask_bits-16))-1);
                }
                else mant &= ~((1 << mask_bits)-1);
                 F32_SET_MANT(f32p, mant);


         if(sgn) return value - 1.0f;
         else return value;
}



// Cephes librairie for float

float MINLOGF = -88.7228391116729996;
float SQRTHF = 0.707106781186547524;

float logff( float xx )
{
register float y;
float x, z, fe;
int e;

x = xx;
fe = 0.0f;

if( x <= 0.0f )
	{
	return( MINLOGF );
	}

x = frexpff( (double)x, &e );
if( x < SQRTHF )
	{
	e -= 1;
	x = x + x - 1.0f; /*  2x - 1  */
	}	
else
	{
	x = x - 1.0f;
	}
z = x * x;

y =
(((((((( 7.0376836292e-2f * x
- 1.1514610310e-1f) * x
+ 1.1676998740e-1f) * x
- 1.2420140846e-1f) * x
+ 1.4249322787e-1f) * x
- 1.6668057665e-1f) * x
+ 2.0000714765e-1f) * x
- 2.4999993993e-1f) * x
+ 3.3333331174e-1f) * x * z;

if( e )
	{
	fe = (e);
	y += -2.12194440e-4f * fe;
	}

y +=  -0.5f * z;  /* y - 0.5 x^2 */
z = x + y;   /* ... + x  */

if( e )
	z += 0.693359375f * fe;

return( z );
}

float LOG2EF = 1.44269504088896341;
float MAXNUMF = 3.4028234663852885981170418348451692544e38;
float MAXLOGF = 88.72283905206835;

static float C1 =   0.693359375;
static float C2 =  -2.12194440e-4;


float expff( float xx )

{
float x, z;
int n;

x = xx;


if( x > MAXLOGF)
	{
	return( MAXNUMF );
	}

if( x < MINLOGF )
	{
	return(0.0f);
	}

/* Express e**x = e**g 2**n
 *   = e**g e**( n loge(2) )
 *   = e**( g + n loge(2) )
 */
z = floorff( LOG2EF * x + 0.5f ); /* floor() truncates toward -infinity. */
x -= z * C1;
x -= z * C2;
n = ftoi(z);

z = x * x;
/* Theoretical peak relative error in [-0.5, +0.5] is 4.2e-9. */
z =
((((( 1.9875691500E-4f  * x
   + 1.3981999507E-3f) * x
   + 8.3334519073E-3f) * x
   + 4.1665795894E-2f) * x
   + 1.6666665459E-1f) * x
   + 5.0000001201E-1f) * z
   + x
   + 1.0f;

/* multiply by power of 2 */
x = ldexp( z, n );

return( x );
}

//

float rac2 ( float x ) {

if (x <= 0)
    return 0;

     return sqrtf(x);}








/////////////////////// Core of the librairie


int lua_toint (lua_State *L, int idx) {
  TValue n;
  const TValue *o = index2adr(L, idx);
  if (tonumber(o, &n)) {
    return ftoi(nvalue(o));
  }
  else
    return 0;
}



float lgtofl[5]= { 0.0f , 1.0f , 2.0f, 3.0f, 4.0f };        // fast tiny int to float conversion

// test the color of a pixel
static int testpixel(lua_State *L)
{
 unsigned short n = lua_gettop(L);
 unsigned char xx, yy, page;
 xx = (lua_toint(L, 1) -1)&0x7F;    // &0x7F is modulus operations (mega fast) that permit not to go outside the screen
yy = (lua_toint(L, 2) -1)&0x3F;
 if(NetB){                   // if not grey mode
if (n==3) page = lua_toint(L, 3);
lua_pushnumber(L,lgtofl[tstpixel(xx,yy,0)]);
return 1; }
else {        // if grey mode
 lua_pushnumber(L,lgtofl[gxPixTest(xx,yy)]);
return 1;   // we send one argument
}
}
static int pixl(lua_State *L)      // draw a pixel
{
 unsigned short n = lua_gettop(L);
 unsigned char coul,page=0;
 unsigned char xx,yy;
 if(n!=3 && n!=4) return 0;
xx = (lua_toint(L, 1) -1)&0x7F;
yy = (lua_toint(L, 2) -1)&0x3F;
coul = lua_toint(L, 3);      // color
if(n==4) page = lua_toint(L, 3);  // in white and black mode, we can write on an other page
if(NetB)setPix((short)xx,(short)yy,page,coul);
else gxPixel((xx),(yy),coul);
return 0;     // we don't send any argument
}




static int print2(lua_State *L)
{

 unsigned short n = lua_gettop(L);   // n is the number of argumennts


 unsigned short i;
 if(NetB){  // not in grey mode
 for( i=1; i<=n; i++ )
 {
   if( lua_isstring(L,i) )
     printf("%s", lua_tostring(L,i) );

   else if( lua_isnil(L,i) )
     printf("nil");

   else if( lua_isboolean(L,i) )
     printf(lua_toboolean(L,i) ? "true" : "false" );


 }
 }
 return 0;   // we don't send any argument
}



void scrollx(char x,unsigned char coul)
{

  if((x&0x7)==0) return;
  if(!NetB)  {
   if(x<0) {x=-x;x&=0x7; rightscroll(x);if(coul<=5){x=x-1; for(;x>=0;x--)gxVLine(127-x,0,63,coul);}}   //pixels make a move at links
   else {x&=0x7;leftscroll(x);if(coul<=5){x=x-1;for(;x>=0;x--)gxVLine(x,0,63,coul);}}

  }
}
void scrolly(char y,unsigned char coul)
{

  if(!NetB) {


   if((y&0x7)==0) return;
   if(y>0)  {y&=0x7; upscroll(y);if(coul<=5){y=y-1;for(;y>=0;y--)line (0,y,127,y,coul);}}   //pixels move down
   else { y=-y;y&=0x7;downscroll(y);if(coul<=5){y=y-1;for(;y>=0;y--)line (0,63-y,127,63-y,coul);}}

  }
  
}

 static int misc(lua_State *L)
{
 unsigned short n = lua_gettop(L);
 static const char *const opts[] ={"space","numcalc","exit","curseur","tostr","cont","prec","map"};
 int o = luaL_checkoption(L, 1, "space", opts);
 long a;  int b;
 unsigned char c = 100;
 char str[30]={0};
 lua_Number parametre;
 lua_Number result = -1;
 if (o>=4 && o<7) a=ftol(lua_tonumber(L, 2));
 if (o>=7 && o<9) {b = lua_toint(L,2);
 if (n==3) c= lua_toint(L,3);
 }
 switch(o)
 {
  case 0: result=(coreleft()-9100); break;    // space free in memory
  case 1: result=100.f; break;                  //we are on algebra fx 2
  case 2: exit(1);                              // return to menu
  case 3: lua_pushnumber(L,(TXTCURSOR_X+1));    // send the position of print cursor
          lua_pushnumber(L,(TXTCURSOR_Y+1));
          return 2;                    // we send 2 arguments
  case 4: ltoa( a, &str,10 ) ;
       lua_pushstring(L, str);  return 1;      // convert a integrer to a string
  case 5: if (a==-1)  contless() ;               // change contrast
 else if (a==1) contplus(); break;
  case 6: ndig=a;break;                            // change print precision with numbers.
  case 7: if(!NetB)gxDrawBmp(lua_tostring(L,2));    // draw a map in grey mode
 }
 lua_pushnumber(L,result);
 return 1;

}

 static int math(lua_State *L)
{
 unsigned short n = lua_gettop(L);
 static const char *const opts[] ={"sin","ln","exp","sqrt","racine"};
 int o = luaL_checkoption(L, 1, "sqrt", opts);      // if no string return sqrt(x)
 float a;
 char str[30]={0};
 lua_Number parametre;
 lua_Number result = -1.f;
  a=lua_tonumber(L, 2);
 switch(o)
 {
  //case 0: result = __sinff(a); break;    deleted (see in math.lua)
  case 1: result = logff(a); break;
  case 2: result = expff(a); break;
  case 3: case 4: result = rac2(a); break;
 }
 lua_pushnumber(L,result);
 return 1;

}




static int randomm(lua_State *L)
{
unsigned short n = lua_gettop(L);
if(n!=1 ) return 0;
lua_pushnumber(L,Randommm((lua_toint(L, 1))));          // push a random number between 0 and argument
return 1;
}


static int waitlua(lua_State *L)
{
unsigned short n = lua_gettop(L);
 if(n==1 ) wait(lua_toint(L, 1));      // wait(100) -> wait 100 * 20ms  approximatively. special use with 1 or 2
 return 0;
}

static int setcolor (lua_State *L)
{
  unsigned short n = lua_gettop(L);
 int parametre;
 if(n!=1 ) return 0;
parametre = lua_toboolean(L, 1);
if(!parametre && !NetB)
gxSetMode(false);     // set white and black mode NetB=true
else if(parametre &&NetB)
gxSetMode(true);      // set grey mode NetB = false
 return 0;
}
// write a string in grey mode at x,y
static int letter (lua_State *L)
{
  unsigned short n = lua_gettop(L);
 int x,y;

 if(!NetB){

x = lua_toint(L, 1)-1;
y = lua_toint(L, 2)-1;

switch(lua_type(L,3)){
case LUA_TSTRING:
writeg(x,y,(char*)lua_tostring ( L , 3  ) ) ;
break;
case LUA_TNUMBER:
writevalue(x,y,ftol(lua_tonumber(L, 3)));
break;
default: break;
}

 return 0;
 }
}

//fill the screen in grey mode
static int fill (lua_State *L)
{
unsigned short n = lua_gettop(L);
 unsigned char x;
if(n!=1 ) return 0;
 if(!NetB){
gxFill(lua_toint(L, 1));
 return 0;
 }
}

// like scanf with integrers and x<= 999,999,999
long InputBoxNum(long max)
{
	int key = 0;
	int nbc = 0;
	long num = 0;
	int i,j;
	char ch;
	char x=TXTCURSOR_X,y=TXTCURSOR_Y;  // print cursor
	char press=1;

        while (thetouche (1,5) == 1) asm hlt;  // wait exe is no more pushed
	while((thetouche (1,5) == 0))      // until it is pushed
	{
		if((thetouche (7,4) == 1))
		{
			num = -1;
			break;
		}
		if(nbc > 0 && (thetouche (4,4) == 1))
		{
			nbc--;
			num /= 10;
                        gotoxy(y,x);
                        for(j=0;j<nbc+1;j++) printf(" ");
		gotoxy(y,x);
		printf("%li",num);
		while (thetouche (4,4) == 1) asm hlt;    // wait 20 ms
		ch=10;
		}
		else if(thetouche (1,1) == 1) ch = 0;
                else if (thetouche (2,1) == 1) ch = 1;
                else if (thetouche (2,2) == 1)        ch = 2;
                else if (thetouche (2,3) == 1)         ch = 3;
                else if (thetouche (3,1) == 1)        ch = 4;
                else if (thetouche (3,2) == 1)             ch = 5;
                else if (thetouche (3,3) == 1)                ch =6;
                else if (thetouche (4,1) == 1)                 ch = 7;
                else if (thetouche (4,2) == 1)                   ch = 8;
                else if (thetouche (4,3) == 1)                    ch = 9;
                else {ch = 10;press=0;}
                if(press==0 && ch < 10 && num <= (max-ch)/10)
		{
                        num = num * 10 + ch;
                press=1;
		nbc++;
		gotoxy(y,x);
		for(j=0;j<nbc;j++) printf(" ");
		gotoxy(y,x);
		printf("%li",num);
		}
		asm hlt;       // wait 40 ms
		asm hlt;
	}
	return num;
}
// the lua function tah use the function just up.
static int numm (lua_State *L)
{
 long x;
 unsigned short n = lua_gettop(L);
 if(NetB){ if(n==0) x= InputBoxNum( 999999999);
 else x= InputBoxNum(ftol(lua_tonumber ( L , 1  ))) ;
 lua_pushnumber(L,(x));
 return 1;
}
return 0;
}
// copy a page to an other in white and black mode

static int copypages (lua_State *L)
{
unsigned short n = lua_gettop(L);
 unsigned char x,y;
if (n==2 && NetB)
{
  x = lua_toint(L, 1);
y = lua_toint(L, 2);
if(x>=0 && y>=0 && x<=6 && y<=6) copypage(x,y);
}
return 0;

}


static int curseur(lua_State *L)
{
 unsigned short n = lua_gettop(L);
if(NetB && n==2)gotoxy(lua_toint(L, 1)-1,lua_toint(L, 2)-1);  // set the print cursor
return 0;
}

// functions used in ligne
void setPixx(unsigned int x,unsigned int y, unsigned int coulpage)
{
 if(NetB) setPix(x,y,coulpage,1);
 else gxPixel(x,y,coulpage) ;
}

line(unsigned char Xd,unsigned char Yd, unsigned char Xf,unsigned char Yf,char couleur)     //drawNB.h
{ 
   short avX,avY,X,Y,dX,dY,cpt,i,x;
   dX=abs(Xf-Xd); 
   dY=abs(Yf-Yd); 
 if(Xd<Xf)avX=1;
 else avX=-1;
 if(Yd<Yf)avY=1;
 else avY=-1;

 if (!dX && !NetB) { // vertical
 if (avY==-1) {x=Yd ; Yd=Yf ;Yf=x;}
      gxVLine(Xd,Yd,Yf,couleur);
 }
else {

   X=Xd;
   Y=Yd; 
   setPixx(X,Y,couleur);
   if (dX>dY) 
      { 
      cpt=dX/2; 
      for (i=1;i<=dX;i++) 
         {
         X=X+avX; 
         cpt=cpt+dY; 
         if (cpt>dX)
            { 
            Y=Y+avY;
            cpt=cpt-dX; 
            } 
	 setPixx(X,Y,couleur);
         } 
      } 
   else 
   { 
      cpt=dY/2; 
      for (i=1;i<=dY;i++) 
         { 
         Y=Y+avY; 
         cpt=cpt+dX; 
         if (cpt>dY) 
            { 
            X=X+avX; 
            cpt=cpt-dY; 
            }
	 setPixx(X,Y,couleur);
	 }
   }
}
}

// draw a ligne(grey mode or White&black) or a square(grey mode only)
static int ligne(lua_State *L)
{
 unsigned short n = lua_gettop(L);
 unsigned char x,y,y1,x1,page=0,xx;
 int coul;
x = (lua_toint(L, 1)-1)&0x7f;
y = (lua_toint(L, 2)-1)&0x3f;
x1 = (lua_toint(L, 3)-1)&0x7f;
y1 = (lua_toint(L, 4)-1)&0x3f;

if (n==6 && !NetB) {   // square
if (x>x1) {xx=x ; x=x1 ;x1=xx;}
if (y>y1) {xx=y ; y=y1 ;y1=xx;}
page= lua_toint(L, 5);
coul = lua_toint(L,6);
gxFillrect(x,y,x1,y1,coul);
if (page!=coul) {
line(x,y,x1,y,page);

gxVLine(x1,y,y1,page);
line(x,y1,x1,y1,page);

gxVLine(x,y,y1,page);
}
} else{
if(n==5) page= lua_toint(L, 5);

line(x,y,x1,y1,page);       }
return 0;


}
static int picture(lua_State *L)   // save or load a casio picture in a white and black buffer
{
 unsigned short n = lua_gettop(L);
 char param;
 char a,b;
 int i;
 param= lua_toint(L,1);
 a= lua_toint(L,2);
 b= lua_toint(L,3);
 if (n==3 && pictadr[2*b]!=0 && a<=6) {
   // copy the page to a picture
 if (param==1)
 {
   copy(MK_FP((0x1A20+40*a),(0x0)),MK_FP((pictadr[2*b]), (pictadr[(2*b)+1])));
   /*for(i = 0x0000;i<0x1000 ;i+=0x0001 )
   {
     pokeb(0x1A20+40*a,i,peekb(pictadr[2*b],(pictadr[(2*b)+1]+i)));
     }*/

 }
 else if (param==2)
 {
   // copy a picture to a page
   copy(MK_FP((pictadr[2*b]),(pictadr[(2*b)+1])),MK_FP((0x1A20+40*a),0x0));
  /*for(i = 0x0000;i<0x1000 ;i+=0x0001 )
   {
     pokeb(pictadr[2*b],(pictadr[(2*b)+1]+i),peekb(0x1A20+40*a,i));
     } */

 }  lua_pushboolean(L,1);      }
 else lua_pushboolean(L,0);
 return 1;
}

// save a number in a lua save (3 saves, 255 numbres per save (234.56 is a valid number))
static int sav(lua_State *L)
{
 unsigned short n = lua_gettop(L);
 char param;
 unsigned char a;
 float b;
 unsigned int* tai;
 param= lua_toint(L,1) -1;
 a= ((unsigned int)(lua_toint(L,2)-1));

 if (n==3 && param >=1 && param <4) {
   b= lua_tonumber(L,3);
 tai=(unsigned int*)&b;
 poke(saveadr[2*(param)], saveadr[(2*(param))+1]+4*a,  tai[0]);
 poke(saveadr[2*(param)],(saveadr[(2*(param))+1])+2+4*a,tai[1]);
 }
 else if(n==2 && param >=1 && param <4)
 {
  tai=(unsigned int*)&b;
 tai[0]=peek(saveadr[2*(param)], saveadr[(2*(param))+1]+4*a );
 tai[1]=peek(saveadr[2*(param)],(saveadr[(2*(param))+1])+2+4*a);
 lua_pushnumber(L,b);
 return 1;}
 return 0;
}

// an other way to print a string in grey mode with casio font (big) (g.letter is better)  you can forget it
static int print3(lua_State *L)
{
 int x,y,mode=0;
 unsigned char* tex;
 x=(lua_toint(L,1)-1)&0x7f;
 y=(lua_toint(L,2)-1)&0x3f;
 mode=(lua_toint(L,3)-1)&0x3;
 unsigned char mod[4] = {TEXT,NORMAL,INVERS,MASK};
 tex=lua_tostring(L,4);
 mode=mod[mode];
 if(!NetB) {
 text(x, y, tex, mode, 0x1A60);
   }
 return 0;
}

static const luaL_Reg glib[] = {
      {"letter", letter},
      {"copypage", copypages},
      {"print2", print3},
      {"pixl", pixl},
      {"tstpixel", testpixel},
      {"setcolor", setcolor},
      {"ligne", ligne},
      {"math", math},
      {"random", randomm},
      {"curseur", curseur},
      {"wait", waitlua},
      {"fill", fill},
      {"inputnum", numm},
      {"picture", picture},
      {"save", sav},
       {"misc", misc},
       {"print", print2},
      {NULL, NULL}  /* sentinel */
   };

void luag_init(lua_State *L)
{
 luaI_openlib(L, "g", glib, 0);
}


// are now opcodes :
/*
static int clear(lua_State *L)
{
 unsigned short n = lua_gettop(L);
 int x;
 if(NetB){
 if (n==0)clearpage(0);
 if (n==1){
 x=lua_toint(L, 1) ;
 if(x>=0 && x<=6)
clearpage(x);
 }
 }
 else gxClearBuff();
 return 0;
} 

static int key(lua_State *L)
{
 unsigned short n = lua_gettop(L);
 unsigned char tch= (lua_toint(L, 1)-1)&0x3F;
 if(n!=1 ) return 0;
lua_pushboolean(L,testkey(tchs[tch+50],tchs[tch]));
return 1;
}
 static int refresh(lua_State *L)
{ if(!NetB)
  gxRefresh();       return 0;
}


static int sprite (lua_State *L)
{
unsigned short n = lua_gettop(L);
 int x,y,num;
if(n!=3 ) return 0;
 if(!NetB){
x = lua_toint(L, 1)-1;
y = lua_toint(L, 2)-1;
StkId o = index2adr(L, 3);
  if(ttype(o)==LUA_TSTRING)
gxSpr_M_C(x,y,svalue(o));

}
return 0;
}

static int inte (lua_State *L)
{
  unsigned short n = lua_gettop(L);
 if(n!=1 ) return 0;
 lua_pushnumber(L,(floorff(lua_tonumber(L, 1))));
 return 1;
}
*/